﻿using System;
using System.Collections.Generic;
using System.Text;
using MapApp.Model;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;

using Affirma.ThreeSharp.Wrapper;

namespace MapApp
{
    public class S3HistoryFile : HistoryFile
    {
        private static string BUCKET_NAME = "mapdev";
        private static string KEY_NAME = "history.file";
        // Insert your AWS access keys here.
        private static readonly string _awsAccessKeyId = "1VPHYTW65A89MPQC29R2";
        private static readonly string _awsSecretAccessKey = "XRi+Srq92Ra8S5Mw+ppvVs2SLtAMG2pmFHKNuifR";

        // The ThreeSharp Library uses DES encryption.  This requires an eight-character key, and
        // and eight-character initialization vector.
        private static readonly string _encryptionKey = "ABCDEFGH";
        private static readonly string _encryptionIV = "IJKLMNOP";

        ThreeSharpWrapper _wrapper = new ThreeSharpWrapper(_awsAccessKeyId, _awsSecretAccessKey);


        public S3HistoryFile()
        {
            HistoryFileLoader = LoadHistoryFile;
            HistoryFileSaver = SaveHistoryFile;
        }

        private List<string> LoadHistoryFile(string fileName)
        {
            //byte[] bytes = _wrapper.GetObject(BUCKET_NAME, KEY_NAME);
            byte[] bytes = _wrapper.GetObject(BUCKET_NAME, fileName);
            MemoryStream memoryStream = new MemoryStream(bytes);
            BinaryFormatter bf = new BinaryFormatter();
            List<string> result = (List<string>)bf.Deserialize(memoryStream);
            return result;
        }

        private void SaveHistoryFile(List<string> contents, string fileName)
        {
            // Don't try to save empty history
            if (contents == null) return;
            if (contents.Count == 0) return;

            MemoryStream memoryStream = new MemoryStream();
            BinaryFormatter bf = new BinaryFormatter();
            bf.Serialize(memoryStream, contents);

            byte[] bytes = memoryStream.ToArray();
            //_wrapper.AddObject(BUCKET_NAME, KEY_NAME, bytes);
            _wrapper.AddObject(BUCKET_NAME, fileName, bytes);
        }
    }
}
